#!/usr/bin/env python3

import os
from sys import argv
import argparse

import numpy as np
import cv2
import torch

from main import render


def _get_parser():
    parser = argparse.ArgumentParser()
    parser.add_argument('input', type=str)
    parser.add_argument('target', type=float, nargs=9)
    parser.add_argument('-o', '--output', type=str, default='out')
    parser.add_argument('-s',
                        '--size',
                        type=int,
                        default=512,
                        choices=[512, 1024])
    return parser


if __name__ == "__main__":
    args = _get_parser().parse_args(argv[1:])
    target = np.array(args.target)
    out, sh_target, sh_est = render(args.input, target, args.size)
    cv2.imwrite(args.output + '_img.png', out)
    cv2.imwrite(args.output + '_target.png', sh_target)
    cv2.imwrite(args.output + '_estimated.png', sh_est)
